CheckBoxTreeCell (JavaFX 13)

Module javafx.controls
Package javafx.scene.control.cell

## Class CheckBoxTreeCell<T>

- java.lang.Object
- - javafx.scene.Node
  - - javafx.scene.Parent
    - - javafx.scene.layout.Region
      - - javafx.scene.control.Control
        - - javafx.scene.control.Labeled
          - - javafx.scene.control.Cell<T>
            - - javafx.scene.control.IndexedCell<T>
              - - javafx.scene.control.TreeCell<T>
                - - javafx.scene.control.cell.CheckBoxTreeCell<T>

- Type Parameters:
    `T` - The type of the elements contained within the TreeView TreeItem instances.
  All Implemented Interfaces:
    `Styleable`, `EventTarget`, `Skinnable`

      public class CheckBoxTreeCell<T>
      extends TreeCell<T>

  A class containing a `TreeCell` implementation that draws a `CheckBox` node inside the cell, along with support for common interactions (discussed in more depth shortly).

  To make creating TreeViews with CheckBoxes easier, a convenience class called `CheckBoxTreeItem` is provided. It is highly recommended that developers use this class, rather than the regular `TreeItem` class, when constructing their TreeView tree structures. Refer to the CheckBoxTreeItem API documentation for an example on how these two classes can be combined.

  When used in a TreeView, the CheckBoxCell is rendered with a CheckBox to the right of the 'disclosure node' (i.e. the arrow). The item stored in `TreeItem.getValue()` will then have the StringConverter called on it, and this text will take all remaining horizontal space. Additionally, by using `CheckBoxTreeItem`, the TreeView will automatically handle situations such as:

  - Clicking on the `CheckBox` beside an item that has children will result in all children also becoming selected/unselected.
  - Clicking on the `CheckBox` beside an item that has a parent will possibly toggle the state of the parent. For example, if you select a single child, the parent will become indeterminate (indicating partial selection of children). If you proceed to select all children, the parent will then show that it too is selected. This is recursive, with all parent nodes updating as expected.
  If it is decided that using `CheckBoxTreeItem` is not desirable, then it is necessary to call one of the constructors where a `Callback` is provided that can return an `ObservableValue<Boolean>` given a `TreeItem` instance. This `ObservableValue<Boolean>` should represent the boolean state of the given `TreeItem`.

  Note that the CheckBoxTreeCell renders the CheckBox 'live', meaning that the CheckBox is always interactive and can be directly toggled by the user. This means that it is not necessary that the cell enter its `editing state` (usually by the user double-clicking on the cell). A side-effect of this is that the usual editing callbacks (such as `on edit commit`) will not be called. If you want to be notified of changes, it is recommended to directly observe the boolean properties that are manipulated by the CheckBox.

  Since:
    JavaFX 2.2

- - ### Property Summary

    Properties
    Type | Property | Description
    --- | --- | ---
    `ObjectProperty<StringConverter<TreeItem<T>>>` | `converter` | The `StringConverter` property.
    `ObjectProperty<Callback<TreeItem<T>,​ObservableValue<Boolean>>>` | `selectedStateCallback` | Property representing the `Callback` that is bound to by the CheckBox shown on screen.

    - ### Properties inherited from class javafx.scene.control.TreeCell

      `disclosureNode, treeItem, treeView`

    - ### Properties inherited from class javafx.scene.control.IndexedCell

      `index`

    - ### Properties inherited from class javafx.scene.control.Cell

      `editable, editing, empty, item, selected`

    - ### Properties inherited from class javafx.scene.control.Labeled

      `alignment, contentDisplay, ellipsisString, font, graphic, graphicTextGap, labelPadding, lineSpacing, mnemonicParsing, textAlignment, textFill, textOverrun, text, underline, wrapText`

    - ### Properties inherited from class javafx.scene.control.Control

      `contextMenu, skin, tooltip`

    - ### Properties inherited from class javafx.scene.layout.Region

      `background, border, cacheShape, centerShape, height, insets, maxHeight, maxWidth, minHeight, minWidth, opaqueInsets, padding, prefHeight, prefWidth, scaleShape, shape, snapToPixel, width`

    - ### Properties inherited from class javafx.scene.Parent

      `needsLayout`

    - ### Properties inherited from class javafx.scene.Node

      `accessibleHelp, accessibleRoleDescription, accessibleRole, accessibleText, blendMode, boundsInLocal, boundsInParent, cacheHint, cache, clip, cursor, depthTest, disabled, disable, effectiveNodeOrientation, effect, eventDispatcher, focused, focusTraversable, hover, id, inputMethodRequests, layoutBounds, layoutX, layoutY, localToParentTransform, localToSceneTransform, managed, mouseTransparent, nodeOrientation, onContextMenuRequested, onDragDetected, onDragDone, onDragDropped, onDragEntered, onDragExited, onDragOver, onInputMethodTextChanged, onKeyPressed, onKeyReleased, onKeyTyped, onMouseClicked, onMouseDragEntered, onMouseDragExited, onMouseDragged, onMouseDragOver, onMouseDragReleased, onMouseEntered, onMouseExited, onMouseMoved, onMousePressed, onMouseReleased, onRotate, onRotationFinished, onRotationStarted, onScrollFinished, onScroll, onScrollStarted, onSwipeDown, onSwipeLeft, onSwipeRight, onSwipeUp, onTouchMoved, onTouchPressed, onTouchReleased, onTouchStationary, onZoomFinished, onZoom, onZoomStarted, opacity, parent, pickOnBounds, pressed, rotate, rotationAxis, scaleX, scaleY, scaleZ, scene, style, translateX, translateY, translateZ, viewOrder, visible`

  - ### Field Summary

    - ### Fields inherited from class javafx.scene.layout.Region

      `USE_COMPUTED_SIZE, USE_PREF_SIZE`

    - ### Fields inherited from class javafx.scene.Node

      `BASELINE_OFFSET_SAME_AS_HEIGHT`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `CheckBoxTreeCell()` | Creates a default `CheckBoxTreeCell` that assumes the TreeView is constructed with `CheckBoxTreeItem` instances, rather than the default `TreeItem`.
    `CheckBoxTreeCell​(Callback<TreeItem<T>,​ObservableValue<Boolean>> getSelectedProperty)` | Creates a `CheckBoxTreeCell` for use in a TreeView control via a cell factory.
    `CheckBoxTreeCell​(Callback<TreeItem<T>,​ObservableValue<Boolean>> getSelectedProperty, StringConverter<TreeItem<T>> converter)` | Creates a `CheckBoxTreeCell` for use in a TreeView control via a cell factory.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `ObjectProperty<StringConverter<TreeItem<T>>>` | `converterProperty()` | The `StringConverter` property.
    `static <T> Callback<TreeView<T>,​TreeCell<T>>` | `forTreeView()` | Creates a cell factory for use in a TreeView control, although there is a major assumption when used in a TreeView: this cell factory assumes that the TreeView root, and all children are instances of `CheckBoxTreeItem`, rather than the default `TreeItem` class that is used normally.
    `static <T> Callback<TreeView<T>,​TreeCell<T>>` | `forTreeView​(Callback<TreeItem<T>,​ObservableValue<Boolean>> getSelectedProperty)` | Creates a cell factory for use in a TreeView control.
    `static <T> Callback<TreeView<T>,​TreeCell<T>>` | `forTreeView​(Callback<TreeItem<T>,​ObservableValue<Boolean>> getSelectedProperty, StringConverter<TreeItem<T>> converter)` | Creates a cell factory for use in a TreeView control.
    `StringConverter<TreeItem<T>>` | `getConverter()` | Returns the `StringConverter` used in this cell.
    `Callback<TreeItem<T>,​ObservableValue<Boolean>>` | `getSelectedStateCallback()` | Returns the `Callback` that is bound to by the CheckBox shown on screen.
    `ObjectProperty<Callback<TreeItem<T>,​ObservableValue<Boolean>>>` | `selectedStateCallbackProperty()` | Property representing the `Callback` that is bound to by the CheckBox shown on screen.
    `void` | `setConverter​(StringConverter<TreeItem<T>> value)` | Sets the `StringConverter` to be used in this cell.
    `void` | `setSelectedStateCallback​(Callback<TreeItem<T>,​ObservableValue<Boolean>> value)` | Sets the `Callback` that is bound to by the CheckBox shown on screen.
    `void` | `updateItem​(T item, boolean empty)` | The updateItem method should not be called by developers, but it is the best method for developers to override to allow for them to customise the visuals of the cell.

    - ### Methods inherited from class javafx.scene.control.TreeCell

      `cancelEdit, commitEdit, createDefaultSkin, disclosureNodeProperty, executeAccessibleAction, getDisclosureNode, getTreeItem, getTreeView, queryAccessibleAttribute, setDisclosureNode, startEdit, treeItemProperty, treeViewProperty, updateTreeItem, updateTreeView`

    - ### Methods inherited from class javafx.scene.control.IndexedCell

      `getIndex, indexProperty, updateIndex`

    - ### Methods inherited from class javafx.scene.control.Cell

      `editableProperty, editingProperty, emptyProperty, getInitialFocusTraversable, getItem, isEditable, isEditing, isEmpty, isItemChanged, isSelected, itemProperty, layoutChildren, selectedProperty, setEditable, setItem, updateSelected`

    - ### Methods inherited from class javafx.scene.control.Labeled

      `alignmentProperty, contentDisplayProperty, ellipsisStringProperty, fontProperty, getAlignment, getClassCssMetaData, getContentBias, getContentDisplay, getControlCssMetaData, getEllipsisString, getFont, getGraphic, getGraphicTextGap, getInitialAlignment, getLabelPadding, getLineSpacing, getText, getTextAlignment, getTextFill, getTextOverrun, graphicProperty, graphicTextGapProperty, isMnemonicParsing, isUnderline, isWrapText, labelPaddingProperty, lineSpacingProperty, mnemonicParsingProperty, setAlignment, setContentDisplay, setEllipsisString, setFont, setGraphic, setGraphicTextGap, setLineSpacing, setMnemonicParsing, setText, setTextAlignment, setTextFill, setTextOverrun, setUnderline, setWrapText, textAlignmentProperty, textFillProperty, textOverrunProperty, textProperty, toString, underlineProperty, wrapTextProperty`

    - ### Methods inherited from class javafx.scene.control.Control

      `computeMaxHeight, computeMaxWidth, computeMinHeight, computeMinWidth, computePrefHeight, computePrefWidth, contextMenuProperty, getBaselineOffset, getContextMenu, getCssMetaData, getSkin, getTooltip, isResizable, setContextMenu, setSkin, setTooltip, skinProperty, tooltipProperty`

    - ### Methods inherited from class javafx.scene.layout.Region

      `backgroundProperty, borderProperty, cacheShapeProperty, centerShapeProperty, getBackground, getBorder, getHeight, getInsets, getMaxHeight, getMaxWidth, getMinHeight, getMinWidth, getOpaqueInsets, getPadding, getPrefHeight, getPrefWidth, getShape, getUserAgentStylesheet, getWidth, heightProperty, insetsProperty, isCacheShape, isCenterShape, isScaleShape, isSnapToPixel, layoutInArea, layoutInArea, layoutInArea, layoutInArea, maxHeight, maxHeightProperty, maxWidth, maxWidthProperty, minHeight, minHeightProperty, minWidth, minWidthProperty, opaqueInsetsProperty, paddingProperty, positionInArea, positionInArea, prefHeight, prefHeightProperty, prefWidth, prefWidthProperty, resize, scaleShapeProperty, setBackground, setBorder, setCacheShape, setCenterShape, setHeight, setMaxHeight, setMaxSize, setMaxWidth, setMinHeight, setMinSize, setMinWidth, setOpaqueInsets, setPadding, setPrefHeight, setPrefSize, setPrefWidth, setScaleShape, setShape, setSnapToPixel, setWidth, shapeProperty, snappedBottomInset, snappedLeftInset, snappedRightInset, snappedTopInset, snapPosition, snapPositionX, snapPositionY, snapSize, snapSizeX, snapSizeY, snapSpace, snapSpaceX, snapSpaceY, snapToPixelProperty, widthProperty`

    - ### Methods inherited from class javafx.scene.Parent

      `getChildren, getChildrenUnmodifiable, getManagedChildren, getStylesheets, isNeedsLayout, layout, lookup, needsLayoutProperty, requestLayout, requestParentLayout, setNeedsLayout, updateBounds`

    - ### Methods inherited from class javafx.scene.Node

      `accessibleHelpProperty, accessibleRoleDescriptionProperty, accessibleRoleProperty, accessibleTextProperty, addEventFilter, addEventHandler, applyCss, autosize, blendModeProperty, boundsInLocalProperty, boundsInParentProperty, buildEventDispatchChain, cacheHintProperty, cacheProperty, clipProperty, computeAreaInScreen, contains, contains, cursorProperty, depthTestProperty, disabledProperty, disableProperty, effectiveNodeOrientationProperty, effectProperty, eventDispatcherProperty, fireEvent, focusedProperty, focusTraversableProperty, getAccessibleHelp, getAccessibleRole, getAccessibleRoleDescription, getAccessibleText, getBlendMode, getBoundsInLocal, getBoundsInParent, getCacheHint, getClip, getCursor, getDepthTest, getEffect, getEffectiveNodeOrientation, getEventDispatcher, getId, getInitialCursor, getInputMethodRequests, getLayoutBounds, getLayoutX, getLayoutY, getLocalToParentTransform, getLocalToSceneTransform, getNodeOrientation, getOnContextMenuRequested, getOnDragDetected, getOnDragDone, getOnDragDropped, getOnDragEntered, getOnDragExited, getOnDragOver, getOnInputMethodTextChanged, getOnKeyPressed, getOnKeyReleased, getOnKeyTyped, getOnMouseClicked, getOnMouseDragEntered, getOnMouseDragExited, getOnMouseDragged, getOnMouseDragOver, getOnMouseDragReleased, getOnMouseEntered, getOnMouseExited, getOnMouseMoved, getOnMousePressed, getOnMouseReleased, getOnRotate, getOnRotationFinished, getOnRotationStarted, getOnScroll, getOnScrollFinished, getOnScrollStarted, getOnSwipeDown, getOnSwipeLeft, getOnSwipeRight, getOnSwipeUp, getOnTouchMoved, getOnTouchPressed, getOnTouchReleased, getOnTouchStationary, getOnZoom, getOnZoomFinished, getOnZoomStarted, getOpacity, getParent, getProperties, getPseudoClassStates, getRotate, getRotationAxis, getScaleX, getScaleY, getScaleZ, getScene, getStyle, getStyleableParent, getStyleClass, getTransforms, getTranslateX, getTranslateY, getTranslateZ, getTypeSelector, getUserData, getViewOrder, hasProperties, hoverProperty, idProperty, inputMethodRequestsProperty, intersects, intersects, isCache, isDisable, isDisabled, isFocused, isFocusTraversable, isHover, isManaged, isMouseTransparent, isPickOnBounds, isPressed, isVisible, layoutBoundsProperty, layoutXProperty, layoutYProperty, localToParent, localToParent, localToParent, localToParent, localToParent, localToParentTransformProperty, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToSceneTransformProperty, localToScreen, localToScreen, localToScreen, localToScreen, localToScreen, lookupAll, managedProperty, mouseTransparentProperty, nodeOrientationProperty, notifyAccessibleAttributeChanged, onContextMenuRequestedProperty, onDragDetectedProperty, onDragDoneProperty, onDragDroppedProperty, onDragEnteredProperty, onDragExitedProperty, onDragOverProperty, onInputMethodTextChangedProperty, onKeyPressedProperty, onKeyReleasedProperty, onKeyTypedProperty, onMouseClickedProperty, onMouseDragEnteredProperty, onMouseDragExitedProperty, onMouseDraggedProperty, onMouseDragOverProperty, onMouseDragReleasedProperty, onMouseEnteredProperty, onMouseExitedProperty, onMouseMovedProperty, onMousePressedProperty, onMouseReleasedProperty, onRotateProperty, onRotationFinishedProperty, onRotationStartedProperty, onScrollFinishedProperty, onScrollProperty, onScrollStartedProperty, onSwipeDownProperty, onSwipeLeftProperty, onSwipeRightProperty, onSwipeUpProperty, onTouchMovedProperty, onTouchPressedProperty, onTouchReleasedProperty, onTouchStationaryProperty, onZoomFinishedProperty, onZoomProperty, onZoomStartedProperty, opacityProperty, parentProperty, parentToLocal, parentToLocal, parentToLocal, parentToLocal, parentToLocal, pickOnBoundsProperty, pressedProperty, pseudoClassStateChanged, relocate, removeEventFilter, removeEventHandler, requestFocus, resizeRelocate, rotateProperty, rotationAxisProperty, scaleXProperty, scaleYProperty, scaleZProperty, sceneProperty, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, screenToLocal, screenToLocal, screenToLocal, setAccessibleHelp, setAccessibleRole, setAccessibleRoleDescription, setAccessibleText, setBlendMode, setCache, setCacheHint, setClip, setCursor, setDepthTest, setDisable, setDisabled, setEffect, setEventDispatcher, setEventHandler, setFocused, setFocusTraversable, setHover, setId, setInputMethodRequests, setLayoutX, setLayoutY, setManaged, setMouseTransparent, setNodeOrientation, setOnContextMenuRequested, setOnDragDetected, setOnDragDone, setOnDragDropped, setOnDragEntered, setOnDragExited, setOnDragOver, setOnInputMethodTextChanged, setOnKeyPressed, setOnKeyReleased, setOnKeyTyped, setOnMouseClicked, setOnMouseDragEntered, setOnMouseDragExited, setOnMouseDragged, setOnMouseDragOver, setOnMouseDragReleased, setOnMouseEntered, setOnMouseExited, setOnMouseMoved, setOnMousePressed, setOnMouseReleased, setOnRotate, setOnRotationFinished, setOnRotationStarted, setOnScroll, setOnScrollFinished, setOnScrollStarted, setOnSwipeDown, setOnSwipeLeft, setOnSwipeRight, setOnSwipeUp, setOnTouchMoved, setOnTouchPressed, setOnTouchReleased, setOnTouchStationary, setOnZoom, setOnZoomFinished, setOnZoomStarted, setOpacity, setPickOnBounds, setPressed, setRotate, setRotationAxis, setScaleX, setScaleY, setScaleZ, setStyle, setTranslateX, setTranslateY, setTranslateZ, setUserData, setViewOrder, setVisible, snapshot, snapshot, startDragAndDrop, startFullDrag, styleProperty, toBack, toFront, translateXProperty, translateYProperty, translateZProperty, usesMirroring, viewOrderProperty, visibleProperty`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface javafx.css.Styleable

      `getStyleableNode`

- - ### Property Detail

    - #### converter

          public final ObjectProperty<StringConverter<TreeItem<T>>> converterProperty

      The `StringConverter` property.
      Returns:
        the `StringConverter` property

    - #### selectedStateCallback

          public final ObjectProperty<Callback<TreeItem<T>,​ObservableValue<Boolean>>> selectedStateCallbackProperty

      Property representing the `Callback` that is bound to by the CheckBox shown on screen.
      See Also:
        `getSelectedStateCallback()`, `setSelectedStateCallback(Callback)`

  - ### Constructor Detail

    - #### CheckBoxTreeCell

          public CheckBoxTreeCell()

      Creates a default `CheckBoxTreeCell` that assumes the TreeView is constructed with `CheckBoxTreeItem` instances, rather than the default `TreeItem`. By using `CheckBoxTreeItem`, it will internally manage the selected and indeterminate state of each item in the tree.

    - #### CheckBoxTreeCell

          public CheckBoxTreeCell​(Callback<TreeItem<T>,​ObservableValue<Boolean>> getSelectedProperty)

      Creates a `CheckBoxTreeCell` for use in a TreeView control via a cell factory. Unlike `CheckBoxTreeCell()`, this method does not assume that all TreeItem instances in the TreeView are `CheckBoxTreeItem`.

      To call this method, it is necessary to provide a `Callback` that, given an object of type TreeItem<T>, will return an `ObservableValue<Boolean>` that represents whether the given item is selected or not. This `ObservableValue<Boolean>` will be bound bidirectionally (meaning that the CheckBox in the cell will set/unset this property based on user interactions, and the CheckBox will reflect the state of the `ObservableValue<Boolean>`, if it changes externally).

      If the items are not `CheckBoxTreeItem` instances, it becomes the developers responsibility to handle updating the state of parent and children TreeItems. This means that, given a TreeItem, this class will simply toggles the `ObservableValue<Boolean>` that is provided, and no more. Of course, this functionality can then be implemented externally by adding observers to the `ObservableValue<Boolean>`, and toggling the state of other properties as necessary.

      Parameters:
        `getSelectedProperty` - A `Callback` that will return an `ObservableValue<Boolean>` that represents whether the given item is selected or not.

    - #### CheckBoxTreeCell

          public CheckBoxTreeCell​(Callback<TreeItem<T>,​ObservableValue<Boolean>> getSelectedProperty,
                                  StringConverter<TreeItem<T>> converter)

      Creates a `CheckBoxTreeCell` for use in a TreeView control via a cell factory. Unlike `CheckBoxTreeCell()`, this method does not assume that all TreeItem instances in the TreeView are `CheckBoxTreeItem`.

      To call this method, it is necessary to provide a `Callback` that, given an object of type TreeItem<T>, will return an `ObservableValue<Boolean>` that represents whether the given item is selected or not. This `ObservableValue<Boolean>` will be bound bidirectionally (meaning that the CheckBox in the cell will set/unset this property based on user interactions, and the CheckBox will reflect the state of the `ObservableValue<Boolean>`, if it changes externally).

      If the items are not `CheckBoxTreeItem` instances, it becomes the developers responsibility to handle updating the state of parent and children TreeItems. This means that, given a TreeItem, this class will simply toggles the `ObservableValue<Boolean>` that is provided, and no more. Of course, this functionality can then be implemented externally by adding observers to the `ObservableValue<Boolean>`, and toggling the state of other properties as necessary.

      Parameters:
        `getSelectedProperty` - A `Callback` that will return an `ObservableValue<Boolean>` that represents whether the given item is selected or not.
        `converter` - A StringConverter that, give an object of type TreeItem<T>, will return a String that can be used to represent the object visually.

  - ### Method Detail

    - #### forTreeView

          public static <T> Callback<TreeView<T>,​TreeCell<T>> forTreeView()

      Creates a cell factory for use in a TreeView control, although there is a major assumption when used in a TreeView: this cell factory assumes that the TreeView root, and all children are instances of `CheckBoxTreeItem`, rather than the default `TreeItem` class that is used normally.

      When used in a TreeView, the CheckBoxCell is rendered with a CheckBox to the right of the 'disclosure node' (i.e. the arrow). The item stored in `TreeItem.getValue()` will then have the StringConverter called on it, and this text will take all remaining horizontal space. Additionally, by using `CheckBoxTreeItem`, the TreeView will automatically handle situations such as:

      - Clicking on the `CheckBox` beside an item that has children will result in all children also becoming selected/unselected.
      - Clicking on the `CheckBox` beside an item that has a parent will possibly toggle the state of the parent. For example, if you select a single child, the parent will become indeterminate (indicating partial selection of children). If you proceed to select all children, the parent will then show that it too is selected. This is recursive, with all parent nodes updating as expected.

      Unfortunately, due to limitations in Java, it is necessary to provide an explicit cast when using this method. For example:

           final TreeView<String> treeView = new TreeView<String>();
           treeView.setCellFactory(CheckBoxCell.<String>forTreeView());

      Type Parameters:
        `T` - The type of the elements contained within the `CheckBoxTreeItem` instances.
      Returns:
        A `Callback` that will return a TreeCell that is able to work on the type of element contained within the TreeView root, and all of its children (recursively).

    - #### forTreeView

          public static <T> Callback<TreeView<T>,​TreeCell<T>> forTreeView​(Callback<TreeItem<T>,​ObservableValue<Boolean>> getSelectedProperty)

      Creates a cell factory for use in a TreeView control. Unlike `forTreeView()`, this method does not assume that all TreeItem instances in the TreeView are `CheckBoxTreeItem` instances.

      When used in a TreeView, the CheckBoxCell is rendered with a CheckBox to the right of the 'disclosure node' (i.e. the arrow). The item stored in `TreeItem.getValue()` will then have the StringConverter called on it, and this text will take all remaining horizontal space.

      Unlike `forTreeView()`, this cell factory does not handle updating the state of parent or children TreeItems - it simply toggles the `ObservableValue<Boolean>` that is provided, and no more. Of course, this functionality can then be implemented externally by adding observers to the `ObservableValue<Boolean>`, and toggling the state of other properties as necessary.

      Type Parameters:
        `T` - The type of the elements contained within the `TreeItem` instances.
      Parameters:
        `getSelectedProperty` - A `Callback` that, given an object of type TreeItem<T>, will return an `ObservableValue<Boolean>` that represents whether the given item is selected or not. This `ObservableValue<Boolean>` will be bound bidirectionally (meaning that the CheckBox in the cell will set/unset this property based on user interactions, and the CheckBox will reflect the state of the `ObservableValue<Boolean>`, if it changes externally).
      Returns:
        A `Callback` that will return a TreeCell that is able to work on the type of element contained within the TreeView root, and all of its children (recursively).

    - #### forTreeView

          public static <T> Callback<TreeView<T>,​TreeCell<T>> forTreeView​(Callback<TreeItem<T>,​ObservableValue<Boolean>> getSelectedProperty,
                                                                                StringConverter<TreeItem<T>> converter)

      Creates a cell factory for use in a TreeView control. Unlike `forTreeView()`, this method does not assume that all TreeItem instances in the TreeView are `CheckBoxTreeItem`.

      When used in a TreeView, the CheckBoxCell is rendered with a CheckBox to the right of the 'disclosure node' (i.e. the arrow). The item stored in `TreeItem.getValue()` will then have the the StringConverter called on it, and this text will take all remaining horizontal space.

      Unlike `forTreeView()`, this cell factory does not handle updating the state of parent or children TreeItems - it simply toggles the `ObservableValue<Boolean>` that is provided, and no more. Of course, this functionality can then be implemented externally by adding observers to the `ObservableValue<Boolean>`, and toggling the state of other properties as necessary.

      Type Parameters:
        `T` - The type of the elements contained within the `TreeItem` instances.
      Parameters:
        `getSelectedProperty` - A Callback that, given an object of type TreeItem<T>, will return an `ObservableValue<Boolean>` that represents whether the given item is selected or not. This `ObservableValue<Boolean>` will be bound bidirectionally (meaning that the CheckBox in the cell will set/unset this property based on user interactions, and the CheckBox will reflect the state of the `ObservableValue<Boolean>`, if it changes externally).
        `converter` - A StringConverter that, give an object of type TreeItem<T>, will return a String that can be used to represent the object visually. The default implementation in `forTreeView(Callback)` is to simply call .toString() on all non-null items (and to just return an empty string in cases where the given item is null).
      Returns:
        A `Callback` that will return a TreeCell that is able to work on the type of element contained within the TreeView root, and all of its children (recursively).

    - #### converterProperty

          public final ObjectProperty<StringConverter<TreeItem<T>>> converterProperty()

      The `StringConverter` property.
      Returns:
        the `StringConverter` property

    - #### setConverter

          public final void setConverter​(StringConverter<TreeItem<T>> value)

      Sets the `StringConverter` to be used in this cell.
      Parameters:
        `value` - the `StringConverter` to be used in this cell

    - #### getConverter

          public final StringConverter<TreeItem<T>> getConverter()

      Returns the `StringConverter` used in this cell.
      Returns:
        the `StringConverter` used in this cell

    - #### selectedStateCallbackProperty

          public final ObjectProperty<Callback<TreeItem<T>,​ObservableValue<Boolean>>> selectedStateCallbackProperty()

      Property representing the `Callback` that is bound to by the CheckBox shown on screen.
      See Also:
        `getSelectedStateCallback()`, `setSelectedStateCallback(Callback)`

    - #### setSelectedStateCallback

          public final void setSelectedStateCallback​(Callback<TreeItem<T>,​ObservableValue<Boolean>> value)

      Sets the `Callback` that is bound to by the CheckBox shown on screen.
      Parameters:
        `value` - the `Callback` that is bound to by the CheckBox shown on screen

    - #### getSelectedStateCallback

          public final Callback<TreeItem<T>,​ObservableValue<Boolean>> getSelectedStateCallback()

      Returns the `Callback` that is bound to by the CheckBox shown on screen.
      Returns:
        the `Callback` that is bound to by the CheckBox shown on screen

    - #### updateItem

          public void updateItem​(T item,
                                 boolean empty)

      The updateItem method should not be called by developers, but it is the best method for developers to override to allow for them to customise the visuals of the cell. To clarify, developers should never call this method in their code (they should leave it up to the UI control, such as the `ListView` control) to call this method. However, the purpose of having the updateItem method is so that developers, when specifying custom cell factories (again, like the ListView `cell factory`), the updateItem method can be overridden to allow for complete customisation of the cell.

      It is very important that subclasses of Cell override the updateItem method properly, as failure to do so will lead to issues such as blank cells or cells with unexpected content appearing within them. Here is an example of how to properly override the updateItem method:

           protected void updateItem(T item, boolean empty) {
               super.updateItem(item, empty);

               if (empty || item == null) {
                   setText(null);
                   setGraphic(null);
               } else {
                   setText(item.toString());
               }
           }

      Note in this code sample two important points:

      1. We call the super.updateItem(T, boolean) method. If this is not done, the item and empty properties are not correctly set, and you are likely to end up with graphical issues.
      2. We test for the `empty` condition, and if true, we set the text and graphic properties to null. If we do not do this, it is almost guaranteed that end users will see graphical artifacts in cells unexpectedly.
      Parameters:
        `item` - The new item for the cell.
        `empty` - whether or not this cell represents data from the list. If it is empty, then it does not represent any domain data, but is a cell being used to render an "empty" row.